﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Hanzen
{
    class DestroyRebuild
    {
        const bool LISTED = true;
        const bool NO_APPENDING = false;
        const int BLOCK_SIZE = 3072;
        const int ERROR_CODE = -1;
        const int FILE_ERROR_CODE = -2;
        const string TEMPORARY_BINARY = "binary.tmp";

        bool combining_character, remove_separators;
        byte[] buffer;
        char separator;
        Encoding encoded;
        int field_count;
        SearchTable s;
        string file_name, new_name, pattern;

        public DestroyRebuild(Encoding e, SearchTable searchTable, string f, string n, int c, char p, bool h, bool r)
        {
            encoded = e;
            s = searchTable;
            file_name = f;
            new_name = n;
            field_count = c;
            separator = p;
            combining_character = h;
            remove_separators = r;

            Dividing d = new Dividing();
            pattern = d.supplying_bits(field_count);
        }

        public int counting()
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            int t, shared_field_count;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    line = file.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, separator, few_fields, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, separator, few_fields, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }
                else
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, field_count, separator, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, field_count, separator, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e177)
            {
                Error.handler( e177.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e178)
            {
                Error.handler( e178.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int renameBinaryFile(string name, bool no_removing)
        {
            int exit_code = 0;
            int size;

            buffer = new byte[BLOCK_SIZE];

            try
            {
                File.Delete(name);
                Stream temporary = File.OpenRead(TEMPORARY_BINARY);
                Stream recent = File.OpenWrite(name);

                while ( ( size = temporary.Read(buffer, 0, BLOCK_SIZE) ) > 0 )
                {
                    recent.Write(buffer, 0, size);
                }

                recent.Close();
                temporary.Close();

                if (! no_removing)
                {
                    File.Delete(TEMPORARY_BINARY);
                }

            }
            catch (IOException e179)
            {
                Error.handler( e179.ToString() );
                exit_code = FILE_ERROR_CODE;
            }
            catch (Exception e180)
            {
                Error.handler( e180.ToString() );
                exit_code = FILE_ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting(int edited_field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e181)
            {
                Error.handler( e181.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e182)
            {
                Error.handler( e182.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting(int edited_field_number, char insert)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend(insert);
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e183)
            {
                Error.handler( e183.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e184)
            {
                Error.handler( e184.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_removing(int edited_field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting_removing(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting_removing(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e185)
            {
                Error.handler( e185.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e186)
            {
                Error.handler( e186.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_LF(int edited_field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e562)
            {
                Error.handler( e562.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e563)
            {
                Error.handler( e563.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_removing_LF(int edited_field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting_removing(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting_removing(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e564)
            {
                Error.handler( e564.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e565)
            {
                Error.handler( e565.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

    }
}
