﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Hanzen
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";
        const string DOUBLE_SPACED = "\r\n\r\n";
        const string NEW_LINE = "\r\n";

        public int versionGuide(double versionNumber, bool comments, bool loud)
        {
            string messages;
            StringBuilder os = new StringBuilder();
            os.Append("Hanzen C# Version ");
            os.Append(versionNumber);
            os.Append(DOUBLE_SPACED);

            if (comments)
            {
                os.Append("hanzen csv                  # Read csv to produce hanzen.txt "); os.Append(NEW_LINE);
                os.Append("hanzen csv zenkaku          # Read csv to produce a zenkaku file. "); os.Append(NEW_LINE);
                os.Append("hanzen < csv > zenkaku      # Read csv to produce a zenkaku file. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 csv          # Every line includes 3 fields. Edit Field-2 only. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -8 csv       # UTF-8 "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -a csv       # Acquire a table name from hanzense.txt "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -b\\x0A csv   # Read csv to produce binary.tmp "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -c- csv      # Skip combining characters. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -d csv       # Do not search a table. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -L csv       # 0Dh is removed from every line. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -m csv       # Read csv to produce binary.tmp "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -q csv       # Commas disappear if placed in quotes. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -s, csv      # CSV "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -s\\l -x- csv # Do not check if the file name includes .csv "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -s\\l csv     # Wiki table "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -s\\x7C csv   # Wiki table "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -u csv       # EUC-JP "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -w csv       # -w shows which table hanzen uses. "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -e2 -y csv       # Do not remove binary.tmp "); os.Append(NEW_LINE);
                os.Append("hanzen -f3 -r2 csv          # Skip combining characters. "); os.Append(NEW_LINE);
                os.Append("hanzen -f255 -t wide        # Check if all lines share the field count. "); os.Append(NEW_LINE);
                os.Append("hanzen -V                   # version "); os.Append(NEW_LINE);
                os.Append("hanzen --help               # Display comments. "); os.Append(NEW_LINE);
                os.Append("hanzen -U --help > file     # Redirect to produce a file."); os.Append(NEW_LINE);
            }
            else
            {
                os.Append("hanzen --help"); os.Append(NEW_LINE);
            }

            messages = os.ToString();
            if (loud)
            {
                Console.Error.WriteLine(messages);
            }
            else
            { // -s
                Console.WriteLine(messages);
            }

            return ERROR_CODE;
        }

    }
}
