﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Hanzen
{
    class StandardInput
    {
        const bool LISTED = true;
        const int ERROR_CODE = -1;

        bool combining_character, remove_separators;
        char separator;
        int field_count;
        SearchTable s;
        string pattern;

        public StandardInput(SearchTable searchTable, int c, char p, bool h, bool r)
        {
            s = searchTable;
            field_count = c;
            separator = p;
            combining_character = h;
            remove_separators = r;

            Dividing d = new Dividing();
            pattern = d.supplying_bits(field_count);
        }

        public int standard_input_counting()
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            int t, shared_field_count;
            string line;

            try
            {
                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    line = Console.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, separator, few_fields, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, separator, few_fields, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }
                else
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, field_count, separator, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, field_count, separator, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }

            }
            catch (IOException e221)
            {
                Error.handler( e221.ToString() );
                exit_code = ERROR_CODE;
            }
            catch (Exception e222)
            {
                Error.handler( e222.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int standard_input_output(int edited_field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        Console.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, field_count, separator, remove_separators);
                        d.editing(line, edited_field_number);
                        Console.WriteLine( d.unite(line, LISTED) );
                    }

                }

            }
            catch (IOException e223)
            {
                Error.handler( e223.ToString() );
                exit_code = ERROR_CODE;
            }
            catch (Exception e224)
            {
                Error.handler( e224.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int standard_input_removing(int edited_field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            SparseKana kana = new SparseKana();
            if (! kana.setting(s) )
            {
                Console.Error.Write("selecting_removing(): ");
                Console.Error.WriteLine("kana.setting(s)");
                Error.handler("selecting_removing(): kana.setting(s)");
                return ERROR_CODE;
            }

            try
            {
                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, separator, few_fields, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        Console.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, field_count, separator, remove_separators, kana);
                        d.editing(line, edited_field_number);
                        Console.WriteLine( d.unite(line, LISTED) );
                    }

                }

            }
            catch (IOException e225)
            {
                Error.handler( e225.ToString() );
                exit_code = ERROR_CODE;
            }
            catch (Exception e226)
            {
                Error.handler( e226.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

    }
}
