﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Hetn
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";
        const string DOUBLE_SPACED = "\r\n\r\n";
        const string NEW_LINE = "\r\n";

        public int versionGuide(double versionNumber, bool comments, bool loud)
        {
            string messages;
            StringBuilder os = new StringBuilder();
            os.Append("Hetn Version ");
            os.Append(versionNumber);
            os.Append(DOUBLE_SPACED);

            if (comments)
            {
                os.Append("hetn                     # Read sutai.xml and arrange lines. "); os.Append(NEW_LINE);
                os.Append("hetn -A-                 # Do not replace \"&amp;\" with &. "); os.Append(NEW_LINE);
                os.Append("hetn -B                  # Replace \"&gt;\" with >. "); os.Append(NEW_LINE);
                os.Append("hetn -f                  # EIGHT equals eight. "); os.Append(NEW_LINE);
                os.Append("hetn -o new              # Read sutai.xml to produce a new file. "); os.Append(NEW_LINE);
                os.Append("hetn -o-                 # Display lines without producing a new file. "); os.Append(NEW_LINE);
                os.Append("hetn -8 -o new           # UTF-8 "); os.Append(NEW_LINE);
                os.Append("hetn -e -o new           # EUC-JP "); os.Append(NEW_LINE);
                os.Append("hetn -L -o new           # 0Dh is removed from every line. "); os.Append(NEW_LINE);
                os.Append("hetn -N                  # Replace \"&#xC;\" with a form-feed character. "); os.Append(NEW_LINE);
                os.Append("hetn -r                  # Arrange lines in descending order. "); os.Append(NEW_LINE);
                os.Append("hetn -S                  # Strictly check </hetn>. "); os.Append(NEW_LINE);
                os.Append("hetn -T                  # Count ticks. "); os.Append(NEW_LINE);
                os.Append("hetn -V                  # version "); os.Append(NEW_LINE);
                os.Append("hetn --help              # Display comments. "); os.Append(NEW_LINE);
                os.Append("hetn -s --help > file    # Produce a help file. ");
            }
            else
            {
                os.Append("hetn --help"); os.Append(NEW_LINE);
            }

            messages = os.ToString();
            if (loud)
            {
                Console.Error.WriteLine(messages);
            }
            else
            { // -s
                Console.WriteLine(messages);
            }

            return ERROR_CODE;
        }

    }
}
