﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Narfi
{
    class DestroyRebuild
    {
        const bool LISTED = true;
        const bool NO_APPENDING = false;
        const int ERROR_CODE = -1;
        const string CLEAR = "0";

        bool full_house, remove_separators, way_of_arranging;
        char ascii, separator;
        Encoding encoded;
        int field_count;
        string file_name, new_name, pattern;

        public DestroyRebuild(Encoding e, string f, string n, string p, int c, char a, char s, bool r, bool w)
        {
            encoded = e;
            file_name = f;
            new_name = n;
            pattern = p;
            field_count = c;
            separator = s;
            remove_separators = r;
            way_of_arranging = w;

            int u = 0x00FF & a;
            ascii = (char)u;

            int k = pattern.IndexOf(CLEAR);
            full_house = (k >= 0) ? false : true;
        }

        public int counting()
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            int t, shared_field_count;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    line = file.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, separator, few_fields, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, separator, few_fields, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }
                else
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        return ERROR_CODE;
                    }

                    f = new FieldsList();
                    d = new Dividing(f, field_count, separator, remove_separators);
                    shared_field_count = d.mapping_fields_list(line);

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        d = new Dividing(f, field_count, separator, remove_separators);
                        t = d.mapping_fields_list(line);
                        if (t != shared_field_count)
                        {
                            Console.WriteLine( d.unite(line, LISTED) );
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e158)
            {
                Error.handler( e158.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e159)
            {
                Error.handler( e159.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting()
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (way_of_arranging)
                {
//        full_house = true;

                    if (field_count <= 0x00FF)
                    { // 0 to 255
                        few_fields = (byte)field_count;

                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, separator, few_fields, remove_separators);
                            newFile.WriteLine( d.reverse_unite(line) );
                        }

                    }
                    else
                    {
                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, field_count, separator, remove_separators);
                            newFile.WriteLine(d.reverse_unite(line));
                        }

                    }

                }
                else
                {
                    if (field_count <= 0x00FF)
                    { // 0 to 255
                        few_fields = (byte)field_count;

                        if (full_house)
                        {
                            for (; ; )
                            {
                                line = file.ReadLine();
                                if (line == null)
                                {
                                    break;
                                }

                                f = new FieldsList();
                                d = new Dividing(f, separator, few_fields, remove_separators);
                                newFile.WriteLine( d.unite(line) );
                            }

                        }
                        else
                        {
                            for (; ; )
                            {
                                line = file.ReadLine();
                                if (line == null)
                                {
                                    break;
                                }

                                f = new FieldsList();
                                d = new Dividing(f, pattern, separator, few_fields, remove_separators);
                                newFile.WriteLine( d.unite(line) );
                            }

                        }

                    }
                    else
                    {
                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, pattern, field_count, separator, remove_separators);
                            newFile.WriteLine( d.unite(line) );
                        }

                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e160)
            {
                Error.handler( e160.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e161)
            {
                Error.handler( e161.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting(int field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, separator, few_fields, remove_separators);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, field_count, separator, remove_separators);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e272)
            {
                Error.handler( e272.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e273)
            {
                Error.handler( e273.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_except_dakuten(int field_number, bool substituted)
        {
            byte few_fields;
            char dakuten = (char)0xDE;
            char handakuten = (char)0xDF;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            if (substituted)
            {
                dakuten = 'H';
                handakuten = 'I';
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingExceptDakuten(f, separator, few_fields, remove_separators, dakuten, handakuten);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingExceptDakuten(f, field_count, separator, remove_separators, dakuten, handakuten);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e568)
            {
                Error.handler( e568.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e569)
            {
                Error.handler( e569.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_except_dakuten_LF(int field_number, bool substituted)
        {
            byte few_fields;
            char dakuten = (char)0xDE;
            char handakuten = (char)0xDF;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            if (substituted)
            {
                dakuten = 'H';
                handakuten = 'I';
            }

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingExceptDakuten(f, separator, few_fields, remove_separators, dakuten, handakuten);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingExceptDakuten(f, field_count, separator, remove_separators, dakuten, handakuten);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e570)
            {
                Error.handler( e570.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e571)
            {
                Error.handler( e571.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_abolishing(int field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, ascii);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, field_count, separator, remove_separators, ascii);
                        d.editing(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e115)
            {
                Error.handler( e115.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e170)
            {
                Error.handler( e170.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_extracting_decimal(int field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, separator, few_fields, remove_separators);
                        d.extracting_decimal_from_field(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, field_count, separator, remove_separators);
                        d.extracting_decimal_from_field(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e168)
            {
                Error.handler( e168.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e153)
            {
                Error.handler( e153.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_extracting_integer(int field_number)
        {
            byte few_fields;
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);
                StreamWriter newFile = new StreamWriter(new_name, NO_APPENDING, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, separator, few_fields, remove_separators);
                        d.extracting_integer_from_field(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, field_count, separator, remove_separators);
                        d.extracting_integer_from_field(line, field_number);
                        newFile.WriteLine( d.unite(line, LISTED) );
                    }

                }

                file.Close();
                newFile.Close();
            }
            catch (IOException e116)
            {
                Error.handler( e116.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e117)
            {
                Error.handler( e117.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_LF()
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (way_of_arranging)
                {
//        full_house = true;

                    if (field_count <= 0x00FF)
                    { // 0 to 255
                        few_fields = (byte)field_count;

                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, separator, few_fields, remove_separators);
                            ca.separatorFollows( d.reverse_unite(line) );
                        }

                    }
                    else
                    {
                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, field_count, separator, remove_separators);
                            ca.separatorFollows( d.reverse_unite(line) );
                        }

                    }

                }
                else
                {
                    if (field_count <= 0x00FF)
                    { // 0 to 255
                        few_fields = (byte)field_count;

                        if (full_house)
                        {
                            for (; ; )
                            {
                                line = file.ReadLine();
                                if (line == null)
                                {
                                    break;
                                }

                                f = new FieldsList();
                                d = new Dividing(f, separator, few_fields, remove_separators);
                                ca.separatorFollows( d.unite(line) );
                            }

                        }
                        else
                        {
                            for (; ; )
                            {
                                line = file.ReadLine();
                                if (line == null)
                                {
                                    break;
                                }

                                f = new FieldsList();
                                d = new Dividing(f, pattern, separator, few_fields, remove_separators);
                                ca.separatorFollows( d.unite(line) );
                            }

                        }

                    }
                    else
                    {
                        for (; ; )
                        {
                            line = file.ReadLine();
                            if (line == null)
                            {
                                break;
                            }

                            f = new FieldsList();
                            d = new Dividing(f, pattern, field_count, separator, remove_separators);
                            ca.separatorFollows( d.unite(line) );
                        }

                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e550)
            {
                Error.handler( e550.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e551)
            {
                Error.handler( e551.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_LF(int field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, separator, few_fields, remove_separators);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingRemoving(f, field_count, separator, remove_separators);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e552)
            {
                Error.handler( e552.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e553)
            {
                Error.handler( e553.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_abolishing_LF(int field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, separator, few_fields, remove_separators, ascii);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new DividingEditing(f, field_count, separator, remove_separators, ascii);
                        d.editing(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e554)
            {
                Error.handler( e554.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e555)
            {
                Error.handler( e555.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_extracting_decimal_LF(int field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, separator, few_fields, remove_separators);
                        d.extracting_decimal_from_field(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, field_count, separator, remove_separators);
                        d.extracting_decimal_from_field(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e556)
            {
                Error.handler( e556.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e557)
            {
                Error.handler( e557.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public int selecting_extracting_integer_LF(int field_number)
        {
            byte few_fields;
            ComboAppend ca = new ComboAppend('\n');
            Dividing d;
            FieldsList f;
            int exit_code = 0;
            string line;

            try
            {
                StreamReader file = new StreamReader(file_name, encoded);

                if (field_count <= 0x00FF)
                { // 0 to 255
                    few_fields = (byte)field_count;

                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, separator, few_fields, remove_separators);
                        d.extracting_integer_from_field(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        f = new FieldsList();
                        d = new Dividing(f, field_count, separator, remove_separators);
                        d.extracting_integer_from_field(line, field_number);
                        ca.separatorFollows( d.unite(line, LISTED) );
                    }

                }

                file.Close();

                File.Delete(new_name);
                Stream newFile = File.OpenWrite(new_name);
                byte[] combo = encoded.GetBytes( ca.built() );
                newFile.Write(combo, 0, combo.Length);
                newFile.Close();
            }
            catch (IOException e558)
            {
                Error.handler( e558.ToString() );
                Console.Error.Write("StreamReader() error: ");
                Console.Error.WriteLine(file_name);
                exit_code = ERROR_CODE;
            }
            catch (Exception e559)
            {
                Error.handler( e559.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

    }
}
