﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Obot
{
    class Hexadecimal
    {
        const int FIELD_COUNT = 20;
        const int ERROR_CODE = 1;
        const int FIELD_SIZE = 3;
        const string EMPTY = "";

        byte[] buffer;
        char fieldSeparator;
        int bufferSize, fieldCount, lineCount, maximumRowNumber, upperLimit;
        string fileName;

        public int run()
        {
            byte c;
            int exit_code = 0;
            int k = 0;
            int rowNumber = 1;

            try
            {
                Stream binaryFile = File.OpenRead(fileName);
                binaryFile.Read(buffer, 0, bufferSize);

                while (k < bufferSize)
                {
                    for (int i = 0; i < fieldCount; ++i)
                    {
                        c = buffer[k++];
                        Console.Write( string.Format("{0:X2}", c) );
                        Console.Write(fieldSeparator);

                        if (c == 0x0A)
                        {
                            lineCount += 1;
                            if (lineCount >= upperLimit)
                            {
                                k = bufferSize;
                            }

                        }

                        if (k >= bufferSize)
                        {
                            break;
                        }

                    }

                    Console.WriteLine(EMPTY);
                    rowNumber += 1;
                    if(rowNumber > maximumRowNumber) {
                        break;
                    }

                }

                binaryFile.Close();
            }
            catch (IOException e50)
            {
                Console.Error.Write("OpenRead() error: ");
                Console.Error.WriteLine(fileName);
                Error.handler( e50.ToString() );
                exit_code = ERROR_CODE;
            }
            catch (Exception e51)
            {
                Error.handler( e51.ToString() );
                exit_code = ERROR_CODE;
            }

            return exit_code;
        }

        public Hexadecimal(string f, int b, int c, int m, int u, char s)
        {
            fileName = f;
            bufferSize = b;
            fieldCount = c;
            maximumRowNumber = m;
            upperLimit = u;
            fieldSeparator = s;

            buffer = new byte[bufferSize];
        }

    }
}
