﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";
        const string DOUBLE_SPACED = "\r\n\r\n";
        const string NEW_LINE = "\r\n";

        public int versionGuide(double versionNumber, bool comments, bool loud)
        {
            string messages;
            StringBuilder os = new StringBuilder();
            os.Append("Sortk C# Version ");
            os.Append(versionNumber);
            os.Append(DOUBLE_SPACED);

            if (comments)
            {
                os.Append("sortk -t, -o new csv       # Read csv to produce a new file. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -L -o new csv    # 0Dh is removed from every line. "); os.Append(NEW_LINE);
                os.Append("sortk -t, < csv > new      # Read csv to produce a new file. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -a4 -h1011 csv   # Compare in Field-1, Field-3 and Field-4. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -j2 csv          # Compare phrases in Field-2. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 csv        # Compare phrases in Field-2. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,3 csv        # Compare phrases from Field-2 to Field-3. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2 csv          # Compare phrases from Field-2 to finish. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k1 -$ csv       # Check if all lines share the field count. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -# csv     # Add ID to each summary. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,3 -# -! csv  # Report ID if any summaries match each other. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -% csv     # Produce manager.txt "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -8 csv     # UTF-8 "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -A- csv    # Do not replace \"&amp;\" with &. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -B csv     # Replace \"&gt;\" with >. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -b csv     # Skip space in the first part of Field-2. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -c- csv    # Skip combining characters. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 --cope csv # --cope means -c- -p -e -o. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 --pic  csv # --pic means -c- -p -i. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -e csv     # EUC-JP "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -f csv     # EIGHT equals eight. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -g csv     # Compare 0.12 with 0.78 in Field-2. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -i csv     # Skip control characters. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -N csv     # Replace \"&#xC;\" with a form-feed character. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -n csv     # Compare 3456 with 9012 in Field-2. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -p csv     # H and I are omitted from ASCII characters. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -q csv     # Commas disappear if placed in quotes. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -r csv     # Arrange in descending order. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -S csv     # Strictly check </hetn>. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -T csv     # Count ticks. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -u csv     # Display a line for each unique summary. "); os.Append(NEW_LINE);
                os.Append("sortk -t, -k2,2 -y csv     # Do not remove temporary files. "); os.Append(NEW_LINE);
                os.Append("sortk -t\\l -k2,2 file      # Wiki table "); os.Append(NEW_LINE);
                os.Append("sortk -t\\l -k2,2 -x- csv   # Do not check if the file name includes .csv "); os.Append(NEW_LINE);
                os.Append("sortk -t\\x7C -k2,2 file    # Wiki table "); os.Append(NEW_LINE);
                os.Append("sortk -U131072 -k2,2 csv   # The number of lines shall not exceed 131072. "); os.Append(NEW_LINE);
                os.Append("sortk -v\\x1F -k2,3 csv     # 1Fh connects phrases from Field-2 to Field-3. "); os.Append(NEW_LINE);
                os.Append("sortk -w~ -k2,4 csv        # ~ is used as a quote. "); os.Append(NEW_LINE);
                os.Append("sortk -V                   # version "); os.Append(NEW_LINE);
                os.Append("sortk --help               # Display comments. "); os.Append(NEW_LINE);
                os.Append("sortk -s --help > file     # Produce a help file. "); os.Append(NEW_LINE);
            }
            else
            {
                os.Append("sortk --help"); os.Append(NEW_LINE);
            }

            messages = os.ToString();
            if (loud)
            {
                Console.Error.WriteLine(messages);
            }
            else
            { // -s
                Console.WriteLine(messages);
            }

            return ERROR_CODE;
        }

    }
}
